/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 232 by dpavlin, Sun Oct 24 11:55:02 2010 UTC revision 271 by dpavlin, Fri Sep 9 18:21:14 2011 UTC
# Line 47  lxc_hostname() { Line 47  lxc_hostname() {
47  }  }
48    
49  lxc_ip() {  lxc_ip() {
50          grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 ||          ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51          grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'          grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54  }  }
55    
56  lxc_status() {  lxc_status() {
57          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | while read name ; do
58                    status=`lxc-info -n $name 2>/dev/null | grep state: | cut -d: -f2`
59                  boot="-"                  boot="-"
60                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
61                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
# Line 64  cleanup_init_scripts() { Line 67  cleanup_init_scripts() {
67          rootfs=$(lxc_rootfs $1)          rootfs=$(lxc_rootfs $1)
68    
69          ls \          ls \
70                    $rootfs/etc/rc?.d/*checkroot* \
71                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
72                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
73                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
74                  $rootfs/etc/rc?.d/*udev* \                  $rootfs/etc/rc?.d/*udev* \
75                    $rootfs/etc/rc?.d/*checkfs* \
76          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
77    
78          echo $1 > $rootfs/etc/hostname          echo $1 > $rootfs/etc/hostname
79            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
80  }  }
81    
82    
# Line 128  lxc_start() { Line 134  lxc_start() {
134    
135          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
136                  lxc_log "$name start"                  lxc_log "$name start"
137                    dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
138                    mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
139                  lxc-start -n $name -o /tmp/${name}.log -d                  lxc-start -n $name -o /tmp/${name}.log -d
140                  lxc-wait  -n $name -s RUNNING                  lxc-wait  -n $name -s RUNNING
141                  lxc-info  -n $name                  lxc-info  -n $name
# Line 138  lxc_start() { Line 146  lxc_start() {
146  lxc_watchdog() {  lxc_watchdog() {
147  name=$1  name=$1
148  rootfs=$(lxc_rootfs $1)  rootfs=$(lxc_rootfs $1)
149    run=$rootfs/var/run
150    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
151    cd $run || echo "can't cd watchdog into $run"
152    
153  while true; do  while true; do
         vps_utmp=${rootfs}/var/run/utmp  
154          tasks=`wc -l < /cgroup/${name}/tasks`          tasks=`wc -l < /cgroup/${name}/tasks`
155            stop_on=1 # init
156            sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
157            if [ "$sulogins" -gt 0 ] ; then
158                    stop_on=`expr $stop_on + $sulogins`
159            fi
160    
161          test -z "$tasks" && exit 1          test -z "$tasks" && exit 1
162          if [ "$tasks" -eq 1 ]; then          if [ "$tasks" -eq $stop_on ]; then
163    
164                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
165                  lxc_log "$name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
166    
167                  case $runlevel in                  case $runlevel in
168                  N*)                  N*)
169                          # nothing for new boot state                          # nothing for new boot state
170                  ;;                  ;;
171                  ??0)                  ??0|unknown)
172                          lxc_log "$name halt"                          lxc_log "$name halt"
173                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
174                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
# Line 171  while true; do Line 187  while true; do
187                  ;;                  ;;
188                  esac                  esac
189          else          else
190                  lxc_log "$name $tasks tasks"                  lxc_log "$name $tasks tasks $sulogins console"
191          fi          fi
192    
193          # time of 5 minutes on it JUST IN CASE...          # time of 5 minutes on it JUST IN CASE...
194          inotifywait -qqt 300 ${vps_utmp}          inotifywait -qqt 300 utmp
195  done  done
196    
197  lxc_log "$name watchdog exited"  lxc_log "$name watchdog exited"

Legend:
Removed from v.232  
changed lines
  Added in v.271

  ViewVC Help
Powered by ViewVC 1.1.26